'use strict';

/* Directives */


angular.module('myApp.directives', []).
        directive('appVersion', ['version', function(version) {
                return function(scope, elm, attrs) {
                    elm.text(version);
                };
            }]);


angular.module('myApp.directives', []).directive('dhxGantt', function() {
    return {
        restrict: 'A',
        scope: false,
        transclude: true,
        template: '<div ng-transclude></div>',
        link: function($scope, $element, $attrs, $controller) {
            //size of gantt
            $scope.$watch(function() {
                return $element[0].offsetWidth + "." + $element[0].offsetHeight;
            }, function() {
                gantt.setSizes();
            });

            //init gantt
            gantt.init($element[0]);
            // Disable task drag
            gantt.attachEvent("onBeforeTaskDrag", function(id, mode, e) {
                return false;
            });
            gantt.attachEvent("onBeforeTaskAdd", function(id, item) {
                // Events: Only one top level. PlanID 
                alert('OnbeforeTaskAdded');
                if (item.$level == 0) {
                    alert('No more top level groups are permitted.');
                    return false
                }

                // Automatically calculate the Groups duration
                if (item.$level == 1) {
                    var startDate = new Date();
                    startDate.setDate(startDate.getDate());
                    item.start_date = startDate;

                    var endDate = new Date();
                    endDate.setDate(startDate.getDate() + 1);
                    item.end_date = endDate;
                    //level1Items++;
                    return true;
                }
            });


            ////////////////////////////////////
/*            var maxLevel = 2;
            var readonlyProperty = false;
            var level1Items = 1;

            // Gantt columns
            gantt.config.columns = [
                {name: "taskname", label: "Task name", width: "*", tree: true}
                , {name: "pc", label: "Process Component", width: 100, align: "left"}
                , {name: "add", label: "", width: 44}
            ];

            //    	gantt.config.scale_height = 18;
            //    	gantt.config.date_scale = "";
            gantt.resetLightbox();
            gantt.init("gantt_here");
            gantt.detachAllEvents();

            // Adjust timescale automatically 
            gantt.config.fit_tasks = true;

            // Remove links options
            gantt.config.drag_links = false;

            // Lightbox Dialog Labels
            gantt.locale.labels.section_taskname = "Task Name";
            gantt.locale.labels.section_pc = "Process Component";

            // Text shown in the lightbox menu bar
            //    	gantt.templates.task_text=function(start, end, task){
            //    	    return "";
            //    	};
            //    	gantt.templates.task_time = function(start,end,task){
            //    	    return "";
            //    	};

            // Hide PC combo box when not at level 2    	
            gantt.form_blocks.select.set_value = function(node, value, ev) {
                node.firstChild.value = "";
                var style = ev.$level == maxLevel ? "" : "none";
                node.style.display = style; // editor area
                node.previousSibling.style.display = style; //section header
                var level = ev.$level;
                gantt.resizeLightbox(); //correct size of lightbox
            };

            // Hide + icon after level 2 using the css file ganttWrapper.css
            gantt.templates.grid_row_class = function(start, end, task) {
                if (task.$level > 1) {
                    return "nested_task"
                }
                return "";
            };



            // Events: One top level is mandatory and can't be deleted. PlanID 
            gantt.attachEvent("onBeforeTaskDelete", function(id, item) {
                if (item.$level == 0) {
                    alert('This level is mandatory and can\'t be deleted.');
                    return false;
                }
            });



            opts = [];
            for (var i = 0; i < 5; i++) {
                var newElement = new Object();
                newElement.key = "Element " + i;
                newElement.label = "Element " + i;
                opts.push(newElement);
            }

            // Configure the popup window to add new task
            gantt.config.lightbox.sections = [
                {name: "taskname", height: 50, map_to: "taskname", type: "textarea", focus: true}
                , {name: "pc", height: 30, map_to: "pc", type: "select", options: opts}
            ];

            // Initial data loaded in the gantt chart
            var tasks = {
                data: [
                    {id: 1, taskname: "Project #1", pc: "", type: gantt.config.types.project, open: true},
                    {id: 2, taskname: "Group #1", pc: "", start_date: new Date(), duration: 1, parent: 1}
                ],
                links: []};

            gantt.unselectTask();
            gantt.clearAll();

            gantt.parse(tasks);

*/
            ////////////////////////////////////
        }
    };
});
